#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	angle = ofGetElapsedTimef();
	ofBackground(0, 0, 0);
	
	for (int i = 0; i < 1000; i++){
		particle myParticle;
		
		float radius = 10;
		angle= angle + 0.03;
		

		
		//float vx = 300 + radius * cos (TWO_PI);
		//float vy = 300 + radius * sin (TWO_PI);

		float x =  300+radius * cos (angle);
		float y =  300+radius * -sin (angle);
		//float x =ofRandom( 300,  radius * cos (TWO_PI));
		//float y = ofRandom( 300, radius * sin (TWO_PI));

		float vx = ofRandom(-2,2);
		float vy = ofRandom(-2,2);
		myParticle.setInitialCondition(x,y,vx, vy);
		// more interesting with diversity :)
		// uncomment this: 
		myParticle.damping = ofRandom(0.008, 0.08);
		particles.push_back(myParticle);
	}
	
}

//--------------------------------------------------------------
void testApp::update(){

	int radius = 100;
	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update

	
	for (int i = 0; i < particles.size(); i++){
		float fx = particles[i].pos.x + radius * cos (angle)/200;
		float fy = particles[i].pos.y + radius * -sin (angle)/100;
		particles[i].resetForce();
		particles[i].addForce(ofRandom(-0.5,0.5),ofRandom(-0.5,0.5));  // gravity
		//particles[i].addForce(2,2);  // gravity
		//particles[i].rotate(fx,fy);
		particles[i].addDampingForce();

		particles[i].update();
		
	}

}

//--------------------------------------------------------------
void testApp::draw(){
	ofEnableAlphaBlending();
	
	for (int i = 0; i < particles.size(); i++){
		int cMap = ofMap(i, 0, particles.size(), 0, 255);
		int aMap = ofMap(i, 0, particles.size(), 0, 100);

		ofSetColor(200,100,cMap,100);
		particles[i].draw();

		if (i>0 && i<particles.size()-1) {
			ofSetColor(255, 255, 255,aMap);
		}

	
	}
	ofDisableAlphaBlending();
	

}

//--------------------------------------------------------------

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	for (int i = 0; i < particles.size(); i++){
		
		float radius = 10;
		angle= angle + 0.01;
				
		float vx = radius * cos (angle);
		float vy = radius * -sin (angle);

		//float vy = ofRandom(-2,2);
		particles[i].setInitialCondition(x,y,vx, vy);	
		particles[i].damping =  ofRandom(0.03, 0.05);

	}
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
